//
// Created by jovian on 15/01/18.
//

#ifndef SERIALIZATION_POINTSYSTEM_H
#define SERIALIZATION_POINTSYSTEM_H


#include <ostream>
#include "Serializable.h"

#define MAX_SIZE 10

class PointSystem : public Serializable {
    // Methods
public:
    PointSystem();

    void addPoint(int p);

    void display();

    friend std::ostream &operator<<(std::ostream &os, const PointSystem &pointSystem);

    friend std::istream &operator>>(std::istream &is, PointSystem &pointSystem);


    // Attributes
private:
    int points[MAX_SIZE];
    int nb;
};


#endif //SERIALIZATION_POINTSYSTEM_H
