#ifndef REPERTOIRE_H_INCLUDED
#define REPERTOIRE_H_INCLUDED

#include "type_def.h"
#include <fstream>

/// Tableau trié TT
// Affichage
void afficherTT(vectPersonne tab, int nb = 10000);

// Ajouter
void ajouterTT(vectPersonne tab, int& nb, Personne p);

// Rechercher
bool rechercherTT(vectPersonne tab, int nb, Personne p);

// Supprimer
void supprimerTT(vectPersonne tab, int& nb, Personne p);

// Lecture répertoire
void lectureRepertoireTT(vectPersonne tab, int& nb);

/// Liste triée LT
// Affichage
void afficherLT(ElementListe* maListe);

// Ajouter
ElementListe* ajouterLT(ElementListe* maListe, Personne p);

// Rechercher
bool rechercherLT(ElementListe* maListe, Personne p);

// Supprimer
ElementListe* supprimerLT(ElementListe* maListe, Personne p);

// Lecture répertoire
ElementListe* lectureRepertoireLT(std::ifstream* flux = nullptr, int iter = 0);

/// Arbre binaire de recherche ABR
// Affichage

// Ajouter

// Rechercher

// Supprimer

// Lecture répertoire

#endif // REPERTOIRE_H_INCLUDED
