#ifndef UTILITAIRES_H_INCLUDED
#define UTILITAIRES_H_INCLUDED

#include "type_def.h"
#include <string>

/// Génère une personne au hasard
Personne genererPersonne(std::string* listNom, std::string* listPrenom, int nbNom, int nbPrenom);

/// Lit les noms d'un fichier, les ajoute dans le tableau passsé en argument et renvoie le cardinal de ce tableau
int initTabNomPrenom(vectNom tab, std::string fichier);

/// Genère 10000 personnes
void genererRepertoire(vectPersonne tab, std::string* listNom, std::string* listPrenom, int nbNom, int nbPrenom);

/// Test d'égalité
bool egalitePersonne(Personne a, Personne b);

/// Test de comparaison : retourne a < b
bool comparerPersonne(Personne a, Personne b);

#endif // UTILITAIRES_H_INCLUDED
